﻿using UnityEngine;
using System.Collections;

public class FireFlickerer : MonoBehaviour {

	public float minMin, maxMin, minMax, maxMax, minFlickerTime, maxFlickerTime;

	private Light fireLight;

	private bool flickeringDown;

	private float nextMin, nextMax, nextFlickerTime, flickerStartTime;

	// Use this for initialization
	void Start () {
		fireLight = this.GetComponent<Light>();
		if(fireLight == null) print("FireFlickerer on " + this.name + " expected a Light but didn't find one!");

		nextMin = getNextMin();
		nextMax = getNextMax();
		nextFlickerTime = getNextFlickerTime();

		fireLight.intensity = nextMax;
		flickeringDown = true;
		flickerStartTime = Time.time;
	}
	
	// Update is called once per frame
	void Update () {
		if(flickeringDown){
			fireLight.intensity = Mathf.Lerp(nextMax, nextMin, (Time.time - flickerStartTime) / nextFlickerTime);
			if(Time.time >= flickerStartTime + nextFlickerTime){
				flickeringDown = false;
				nextMax = getNextMax();
				nextFlickerTime = getNextFlickerTime();
				flickerStartTime = Time.time;
			}
		} else {
			fireLight.intensity = Mathf.Lerp(nextMin, nextMax, (Time.time - flickerStartTime) / nextFlickerTime);
			if(Time.time >= flickerStartTime + nextFlickerTime){
				flickeringDown = true;
				nextMin = getNextMax();
				nextFlickerTime = getNextFlickerTime();
				flickerStartTime = Time.time;
			}
		}
	}

	float getNextMin(){
		return Random.Range(minMin, maxMin);
	}

	float getNextMax(){
		return Random.Range(minMax, maxMax);
	}

	float getNextFlickerTime(){
		return Random.Range(minFlickerTime, maxFlickerTime);
	}
}
